/*;  khbintree.h {\documentstyle{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.3 $$ {\rhead{\sl khbintree.h\quad\thepage}} */
/*;  $$Date: 1997/09/14 09:54:39 $$  */
/*;  $$Source: /home/shiiba/KhC++LibDevelop/trees/khbintree.h,v $$  */


/*
ΥץϡScott Robert Ladd ˤ C++ Templates and
Tools˷ǺܤƤ룲ʬڤΥץ bintree.h 򸵤ˤƤޤ

ѹϼ̤Ǥ

1. Υץϡ㳰(try, throw, catch ʤɤȤ)
   ɤޤǤޤ assert ޥȤ֤
   ޤ

2. class KhBinaryTree<D>  public ʥдؿ

	   D * GetPtrToData(const D & item);

   ɲäޤĥ꡼˼ϿƤǡ򡤥饹 D 
   黻== ˤäɤơ item Ǥǡ
   ȯ줿顤ΥǡؤΥݥ󥿤֤ޤ item
   Ǥǡȯʤä顤NULL ֤ޤ

   ǡؤΥݥ󥿤֤ΤϴǤĥ꡼˼Ǽ줿ǡ
   ľɬפơΤ褦ʴؿѰդޤ
   

   Ѥ򼨤ޤ

   KhBinaryTreeIterator<int> itrint(tree_int);
   ...
   itrint.Smallest();
   while ((int *)itrint)
   {
     int *pInt = (int *)itrint;
     *pInt += 5;
     cout << *itrint << endl;
     ++itrint;
   }

   ()
      Ǥϡĥ꡼˳ǼƤǡˡΧ 5 û
      Ƥޤ

ΥإåեǤϡ

  struct KhTreeNode<D>,
  class KhBinaryTree<D>,
  class KhBinaryTreeIterator<D>

Ƥޤ

ƥץ졼ȥ饹 D Ǥϡ

  D&  operator =  (const D& aRhs)          Ʊ黻
  int operator == (const D& aRhs) const    黻
  int operator <  (const D& aRhs) const    ӱ黻

Ƥ뤳ȤɬפǤ!= (黻), > (ӱ黻)
ʤƤ⹽ޤint, long, float, double Ȥ߹ߤ
ϡƤޤ

*/

//=============================================================
//  Binary Tree Classes     bintree.h   v3.00
//      Template for standard binary tree types
//      Copyright 1993-1995 Scott Robert Ladd
//=============================================================

#ifndef KHBINTREE_H
#define KHBINTREE_H

#include <stddef.h>
#include <limits.h>
#include "khsimple.h"
#include "khboolean.h"

//-------------------------------------------------------------
//  KhTreeNode
//      A node in a binary tree
//-------------------------------------------------------------

template <class D>
struct KhTreeNode
{
  // links
  KhTreeNode<D> * Less;
  KhTreeNode<D> * More;
  KhTreeNode<D> * Parent;

  // contents
  D Data;

  KhTreeNode(                  // constructor
    const D & item,            // data
    KhTreeNode<D> * sentinel   // sentinel
    );

  KhTreeNode(); // creates a sentinel node

  KhTreeNode(                  // copy constructor
    const KhTreeNode<D> & node // right hand side
    );

  void operator = (            // assignment operator
    const KhTreeNode<D> & node // right hand side
    );
};

//-------------------------------------------------------------
//  KhBinaryTree
//      A basic binary tree
//-------------------------------------------------------------

// added by Yutaka ICHIKAWA (Tue Jul 13 20:57:39 1999)
// egcs-1.1.2 ǤϡιԤʤȡ7Բ friend ̤ʤ
template <class D> class KhBinaryTreeIterator;

template <class D>
class KhBinaryTree
{
 friend
  class KhBinaryTreeIterator<D>;

 public:

  KhBinaryTree();       // constructor

  KhBinaryTree(         // copy constructor
    const KhBinaryTree<D> & tree
    );

  ~KhBinaryTree();

  void operator = (     // assignment operator
    const KhBinaryTree<D> & tree
    );

  void
  Insert(		// Store a data
   const D & item	// data to be stored
   //
   // When a data which is judged as equivalent to "item" by
   // operator == exists, the data will be replaced with "item".
   //
   );

  KhBoolean		// NO/no such data
  Delete(		// Delete a data
   const D & item	// data to be deleted
   );

  void
  Walk(			// Walk around calling function
    void (* func)(const D & item) // pointer to function
    );

  void
  Erase();		// Delete all leaves

  unsigned int          // number of locks
  GetLockCount();	// Return the number of locks

  const KhTreeNode<D> *	// pointer to sentinel
  GetSentinel();	// Return pointer to sentinel

  D *                   // pointer to the retrieved data
  GetPtrToData(		// Retrieve an item
    const D & item	// item to be retrieved
    //
    // If a data equivalent to the argument "item" has been
    // stored in the tree already, GetPtrToData returns the
    // pointer to the data. Otherwise, GetPtrToData returns NULL.
    //
    );

 protected:
  KhTreeNode<D> * Root;     // root node
  KhTreeNode<D> * Sentinel; // sentinel node

  unsigned int LockCount; // number of iterator locks
  unsigned int Count;

  // function called during traverse
  void (*WalkFunc)(const D & item);

  // function to create and delete nodes
  KhTreeNode<D> * CreateNode
  (
   const D & item
   );

  void DeleteNode
  (
   KhTreeNode<D> * node
   );

  // internal insert function
  KhTreeNode<D> * InternalInsert
  (
   const D & item
   );

  // recursive copy function
  void RecursiveCopy
  (
   KhTreeNode<D> * node,
   KhTreeNode<D> * sent
   );

  // recursive traversal function
  void RecurseWalk
  (
   KhTreeNode<D> * node
   );

  // recursive deletion function
  void RecursiveDelete
  (
   KhTreeNode<D> * node
   );

  // find minimum node
  KhTreeNode<D> * Minimum
  (
   KhTreeNode<D> * node
   );

  // find maximum node
  KhTreeNode<D> * Maximum
  (
   KhTreeNode<D> * node
   );

  // find successor node
  KhTreeNode<D> * Successor
  (
   KhTreeNode<D> * node
   );

  // find predecessor node
  KhTreeNode<D> * Predecessor
  (
   KhTreeNode<D> * node
   );

  // find node containing specific item
  KhTreeNode<D> * Search
  (
   const D & item
   );
};

//---------------------------
// binary tree iterator class
//---------------------------

template <class D>
class KhBinaryTreeIterator
{
 public:
  KhBinaryTreeIterator(	// constructor
    KhBinaryTree<D> & bt
    );

  KhBinaryTreeIterator(	// copy constructor
    KhBinaryTreeIterator<D> & iter
    );

  ~KhBinaryTreeIterator(); // destructor

  void
  operator =(		// assignment operator
    KhBinaryTreeIterator<D> & iter
    );

  void
  Smallest();		// Move "iterator node" to the smallest

  void
  Largest();		// Move "iterator node" to the largest

  void
  operator ++ ();	// Move "iterator node" to larger node

  void
  operator -- ();	// Move "iterator node" to smaller node

  D
  operator * ();	// Return data which "iterator node" holds

  operator D*();
  // Return pointer to the data which "iterator node" holds or
  // NULL when "iterator node" is Sentinel

 protected:
  KhBinaryTree<D> & Tree;
  KhTreeNode<D>   * Node;
};

#endif

/*; end of file */
