/* khdfstream.cc {\documentstyle{jsrc2latex}\rhead{\sl khdfstream.cc\quad\thepage}
   \font\tenrm=cmtt10}
{\ \begin{verbatim}
$RCSfile: khkhdfstream.cc,v $  $Revision: 1.1 $
$Date: 1997/08/28 05:29:50 $  by KyotoHydro
\end{verbatim}}
{\ {\setlength{\parskip}{4pt}% latex-mode

}% end of latex-mode }
*/

#include <stdio.h>
#include <assert.h>
#include "khdfstream.h"

void KhDfstream::close()  // close the data file
{
  if (openFlag == 1)
    {
      ifstream::close();
      unlink(dfname);
      openFlag = 0;
    }
}

void KhDfstream::open(    // open a data file.
const char *name)       // file name to be opened
{
  // Internally a working file will be created from the data file
  // by ignoring comment strings. Actually users read data from this
  // working file.

  if (openFlag == 1)
    close();

  ifstream fi(name);
  if (!fi)
    { setstate(failbit);  return; }

  if (!tmpnam(dfname))
    { setstate(failbit);  return; }

  ofstream fo(dfname);
  if (!fo)
    { setstate(failbit);  return; }

  char c;
  char clast = '\n';
  while (fi.get(c))
    {
      if (c == '\'' || c == '\"')
        {
          char cmt = c;   fo.put(c);
          while (fi.get(c))
            { fo.put(c);  if (c == cmt) break; }
          assert(c == cmt);
        }
      else if (c == '#')
        {
          while (fi.get(c))
            if (c == '\n') break;

          assert(c == '\n');
          if (clast != '\n')
            fo.put(c);

        }
      else
        fo.put(c);

      clast = c;
    }

  fo.close();
  fi.close();
  cout.flush();
  ifstream::open(dfname);
  openFlag = 1;
}

KhDfstream::~KhDfstream()
{
  if (openFlag == 1) unlink(dfname);
}

/* end of file {\ % The following part will be omitted in tex file
\begin{comment}\begin{verbatim}
This part is not included in the tex output.
$Revision: 1.1 $

# Local Variables: ***
# tab-width: 4 ***
# End: ***
\end{verbatim}\end{comment}
} */
