/* ksedge.cc */
/* $Lastupdate: Mon Jan 29 11:43:40 2001 $ */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#include "ksedge.h"				// defines class Edge, KsEdge
#include "dfopen.h"				// defines function dataFileOpen

Boolean Edge::RegisterUpperEdge // p  upperEdgeArray Ͽ
(
	Edge* p
)
{
	for (int i = 0; i < numberOfUpperEdges; i++)
	{
		if (upperEdgeArray[i] == NULL)
		{
			upperEdgeArray[i] = p;
			return (Boolean)YES;
		}
	}

	return (Boolean)NO;
}

void Edge::ParametersInFlowModel // ήη׻ɬפʥѥ᥿
								 // ɤ߹
(
	double man,					 // ޥ˥󥰤ٷ (m-s)
    double m,					 // q = alpha * pow(h, m)  m
	double k, 					 // Ʃ巸 (m/s)
	double d, 					 // Aظ (m)
	double gamma, 				 // ַͭΨ (-)
	double theta, 
	double cmin, 				 // minimum C = dQ/dA
	double Qlevel, 
	double eps, 
	int ndiv, 					 // ֺʬʬ (-)
	int dt						 // time_step (s)
)
{
	mMan = man;
	mM = m;
	mK = k;
	mD = d;
	mGamma = gamma;
	mTheta = theta;
	mCmin = cmin;
	mQlevel = Qlevel;
	mEps = eps;
	mN = ndiv;
	mDt = dt;

	mQc = new double[mN+1];
	mQn = new double[mN+1];

	if (mAtr == 1)
	{
		mAlpha = sqrt(mGrd) / mMan;
		mA = mK * mGrd / mGamma;
		mDepth = mD * mGamma;
		mDx = mL / (double)mN;
	}

	mQsmall = mQlevel * mEps * 0.001 / 3600.;
	// mQlevel: ή̤η׻ͤδ (mm/hour). 10.0 ɸ.
	// mEps: ׻ (-). 0.001 ɸ
}

// void Edge::TopographicData // åη׻¤٤줿
// 						   // edge connection V.1 ե
// 						   // ɤ߹
// (
//  	FILE* fpTopo
// )
// {
// 	// åֹɤ߹
// 	fscanf(fpTopo, "%ld", &mNum);
// 	assert(mNum > 0);
// 
// 	// ή¦ƻʬοɤ߹
// 	assert(fscanf(fpTopo, "%d", &numberOfUpperEdges) == 1);
// 	assert(numberOfUpperEdges >= 0);
// 
// 	// upperEdgeNumArray, upperEdgeArray γ
// 	if (numberOfUpperEdges > 0) 
// 	{
// 		upperEdgeNumArray = new long[numberOfUpperEdges];
// 		upperEdgeArray = new Edge*[numberOfUpperEdges];
// 	}
// 	else						// numberOfUpperEdges == 0
// 	{
// 		upperEdgeNumArray = new long;
// 		upperEdgeArray = new Edge*;
// 	}
// 
// 	// upperEdgeArray ν
// 	for (int i = 0; i < numberOfUpperEdges; i++)
// 		upperEdgeArray[i] = NULL;
// 
// 	// ή¦ƻʬֹɤ߹
// 	for (int i = 0; i < numberOfUpperEdges; i++)
// 	{
// 		long num;
// 		assert(fscanf(fpTopo, "%ld", &num) == 1);
// 		upperEdgeNumArray[i] = num;
// 	}
// 
// 	// ή¦ƻʬοɤ߹
// 	int tmp;
// 	assert(fscanf(fpTopo, "%d", &tmp) == 1);
// 	assert(tmp >= 0);
// 
// 	// ή¦ƻʬֹɤ߹
// 
// 	Boolean outEdgeFromLowerEnd = (Boolean)NO;
// 	// üήФ륨å YES
// 
// 	for (int i = 0; i < tmp; i++)
// 	{
// 		long num;
// 		assert(fscanf(fpTopo, "%ld", &num) == 1);
// 		if (num < 0) outEdgeFromLowerEnd = (Boolean)YES;
// 	}
// 
// 	// å°ɤ߹
// 
// 	assert(fscanf(fpTopo, "%d", &tmp) == 1);
// 	assert(tmp == 1 || tmp == 2);
// 	mAtr = tmp;
// 
// 	// ήǲüΥåɤǧ
// 	if (mAtr == 2 && outEdgeFromLowerEnd == (Boolean)NO) // ǲüå
// 		lowestEdge = (Boolean)YES;
// 	else 
// 		lowestEdge = (Boolean)NO;
// 
// 	// mAtr  1 ΤȤ(ή-ήåΤȤ)
// 	// åĹۡѤɤ߹
// 
// 	if (mAtr == 1)
// 	{
// 		double wlen, wgrd, warea;
// 		assert(fscanf(fpTopo, "%lf %lf %lf", &wlen, &wgrd, &warea)
// 			   == 3);
// 		assert(wlen > 0.0);
// 		assert(wgrd > 0.0);
// 		assert(warea > 0.0);
// 
// 		mArea = warea;
// 		mWidth = mArea / wlen;
// 
// // 		printf("wlen : %f\n", wlen);
// // 		printf("wgrd : %f\n", wgrd);
// 
// 		// wlen ϿʿΥʤΤ3ĹѴ
// 		mL = wlen * sqrt(1.0 + wgrd*wgrd);
// 
// // 		printf("mL : %f\n", mL);
// 
// 		// wgrd  tangent ͤʤΤǡsin ͤѴ
// 		wgrd = atan(wgrd);
// 		mGrd = sin(wgrd);
// 
// 		// mCos 롣mCos Ϲ߿嶯٤˾褸
// 		mCos = cos(asin(mGrd));
// 	}
// 
// // 	// for debugging
// //  	printf("%ld : %d %f %f %f %f %f %d %d\n",
// //  		mNum, mAtr, mL, mArea, mWidth, mGrd, mCos,
// //  		   numberOfUpperEdges, lowestEdge);
// }

void Edge::TopographicData // åη׻¤٤줿
						   // edge connection V.? ե
						   // ɤ߹
(
 	FILE* fpTopo,
    int wTopoDataType
)
{
	// åֹɤ߹()
	fscanf(fpTopo, "%ld", &mNum);
	assert(mNum > 0);

	// åֹɤ߹(V.2, V.3)
	if (wTopoDataType == 2 || wTopoDataType == 3)
	{
		fscanf(fpTopo, "%lf %lf %lf", &mX, &mY, &mZ);
		mUpperNode = mLowerNode = 0;
		mUpX = mUpY = mUpZ = mLowX = mLowY = mLowZ = 0.0;
	}
	// å岼üֹ椪 x,y,z ɸͤɤ߹(V.4, V.5)
	else if (wTopoDataType == 4 || wTopoDataType == 5)
	{
		fscanf(fpTopo, "%ld %lf %lf %lf %ld %lf %lf %lf", 
			&mUpperNode, &mUpX, &mUpY, &mUpZ, 
			&mLowerNode, &mLowX, &mLowY, &mLowZ);
		mX = mY = mZ = 0.0;
	}
	else
	{
		mX = mY = mZ = 0.0;
		mUpperNode = mLowerNode = 0;
		mUpX = mUpY = mUpZ = mLowX = mLowY = mLowZ = 0.0;
	}

	// ή¦åοɤ߹()
	assert(fscanf(fpTopo, "%d", &numberOfUpperEdges) == 1);
	assert(numberOfUpperEdges >= 0);

	// upperEdgeNumArray, upperEdgeArray γ
	if (numberOfUpperEdges > 0) 
	{
		upperEdgeNumArray = new long[numberOfUpperEdges];
		upperEdgeArray = new Edge*[numberOfUpperEdges];
	}
	else						// numberOfUpperEdges == 0
	{
		upperEdgeNumArray = new long;
		upperEdgeArray = new Edge*;
	}

	// upperEdgeArray ν
	for (int i = 0; i < numberOfUpperEdges; i++)
		upperEdgeArray[i] = NULL;

	// ή¦åֹɤ߹()
	for (int i = 0; i < numberOfUpperEdges; i++)
	{
		long num;
		assert(fscanf(fpTopo, "%ld", &num) == 1);
		upperEdgeNumArray[i] = num;
	}

	// ή¦åοɤ߹()
	int tmp;
	assert(fscanf(fpTopo, "%d", &tmp) == 1);
	assert(tmp >= 0);

	// ή¦åֹɤ߹()

	Boolean outEdgeFromLowerEnd = (Boolean)NO;
	// üήФ륨å YES

	for (int i = 0; i < tmp; i++)
	{
		long num;
		assert(fscanf(fpTopo, "%ld", &num) == 1);
		if (num < 0) outEdgeFromLowerEnd = (Boolean)YES;
	}

	// å°ɤ߹()

	assert(fscanf(fpTopo, "%d", &tmp) == 1);
	assert(tmp == 1 || tmp == 2);
	mAtr = tmp;

	// ήǲüΥåɤǧ
	if (mAtr == 2 && outEdgeFromLowerEnd == (Boolean)NO) // ǲüå
		lowestEdge = (Boolean)YES;
	else 
		lowestEdge = (Boolean)NO;

	// mAtr  1 ΤȤ(ή-ήåΤȤ)
	// åĹۡѤɤ߹()

	if (mAtr == 1)
	{
		double wlen, wgrd, warea;
		assert(fscanf(fpTopo, "%lf %lf %lf", &wlen, &wgrd, &warea)
			   == 3);
		assert(wlen > 0.0);
		assert(wgrd > 0.0);
		assert(warea > 0.0);

		mArea = warea;
		mWidth = mArea / wlen;

// 		printf("wlen : %f\n", wlen);
// 		printf("wgrd : %f\n", wgrd);

		// wlen ϿʿΥʤΤ3ĹѴ
		mL = wlen * sqrt(1.0 + wgrd*wgrd);

// 		printf("mL : %f\n", mL);

		// wgrd  tangent ͤʤΤǡsin ͤѴ
		wgrd = atan(wgrd);
		mGrd = sin(wgrd);

		// mCos 롣mCos Ϲ߿嶯٤˾褸
		mCos = cos(asin(mGrd));
	}

	// ήʬΨήѤɤ߹(V.3, V.5)
	if (wTopoDataType == 3 || wTopoDataType == 5)
	{
		assert(fscanf(fpTopo, "%lf %lf", &mDist, &mUpperArea) == 2);
		assert(mDist > 0.0);
		assert(mUpperArea >= 0.0);

// 		// for debugging
// 		printf("%ld %f %f\n", mNum, mDist, mUpperArea);
	}

// 	// for debugging
//  	printf("%ld : %d %f %f %f %f %f %d %d\n",
//  		mNum, mAtr, mL, mArea, mWidth, mGrd, mCos,
//  		   numberOfUpperEdges, lowestEdge);
}

void Edge::DistributionRate(void)
{
	if (mAtr == 2)				// ή-ƻåξ
	{
		int couter = 1;	// ʬޤ᤿ή¦ʬήåο
		for (int i = 0; i < numberOfUpperEdges; i++)
		{
			if (upperEdgeNumArray[i] < 0) // ή¦ʬήå
									      // ¸ߤ
			{
				couter++;
			}
		}

		mDist = 1.0 / couter;
		return ;
	}

	// ή-ήåξ

	// $mDist = mWidth \sqrt(mGrd) / 
	// 		\sum_{m=1}^{N} mWidth_{m} \sqrt(mGrd_{m})

	double tmpa, tmpb;
	tmpa = tmpb = mWidth * sqrt(mGrd);

	int counter = 1;				// ή¦ʬήåο

	Boolean anyBRedge = (Boolean)NO;
	// ή¦ʬήå˰ĤǤή-ƻå¸ߤ
	// 硢YES 

	for (int i = 0; i < numberOfUpperEdges; i++)
	{
//		printf("%ld : %ld\n", mNum, upperEdgeArray[i]->Num());

		// ή¦ʬήå¸ߤ
		if (upperEdgeNumArray[i] < 0)
		{
			counter++;

			// ʬήåή-ήåǤ
			if (upperEdgeArray[i]->Atr() == 1)
			{
				tmpb += upperEdgeArray[i]->Width() * 
					sqrt(upperEdgeArray[i]->Gradient());
			}
			else if (upperEdgeArray[i]->Atr() == 2)
			{
				anyBRedge = (Boolean)YES;
			}
		}
	}

	if (anyBRedge == (Boolean)NO)
	{
		mDist = tmpa / tmpb;
	}
	// ή¦ʬήå˰ĤǤή-ƻå¸ߤ
	// ϡμȤʤΤǡñƬǳ 
	else
		mDist = 1.0 / counter;

// 	// for debugging
// 	printf("%ld %f\n", mNum, mDist);
}

void Edge::CalcUpperArea(void)
{
// 	if (mAtr == 2)				// ή-ƻåξ
// 	{
// 		mUpperArea = 0.0;
// 
// // 		// for debugging
// // 		printf("%ld %f %f\n", mNum, mDist, mUpperArea);
// 
// 		return ;
// 	}
// 
// 	// ή-ήåξ

	// ήή륨å n ĤȤ
	// $mUpperArea = \sum_{i=1}^{n}(mUpperArea_i + mArea_i) \times mDist$

	mUpperArea = 0.0;
	for (int i = 0; i < numberOfUpperEdges; i++)
	{
//		printf("%ld : %ld\n", mNum, upperEdgeArray[i]->Num());

		// ήή륨å¸ߤ
		if (upperEdgeNumArray[i] > 0)
		{
			// ήåή-ήåǤ
			if (upperEdgeArray[i]->Atr() == 1)
			{
				mUpperArea += upperEdgeArray[i]->Area() +
					upperEdgeArray[i]->UpperArea();
			}
			else if (upperEdgeArray[i]->Atr() == 2)
			{
				cerr << "wrong connection of edges:" << endl;
				cerr << "from " << upperEdgeArray[i]->Num() << " to "
					 << Num() << endl;
				exit(1);
			}
		}
	}

	mUpperArea *= mDist;

// 	// for debugging
// 	printf("%ld %f %f\n", mNum, mDist, mUpperArea);
}

void Edge::Discharge
(
	double disUpperEnd,			// üǤή
	double disLowerEnd			// üǤή
)
{
	mQc[0] = mQn[0] = disUpperEnd;
	mQc[mN] = mQn[mN] = disLowerEnd;

	// η׻̤ή̤֤ǵ
	for (int i = 1; i <= mN-1; i++)
	{
		mQc[i] = mQn[i] = mQc[0] + 
			(mQc[mN] - mQc[0]) / (double)mN * (double)i ;
	}
}

void Edge::Discharge
(
	double* disUpperEnd,			// üǤή
	double* disLowerEnd				// üǤή
)
{
	*disUpperEnd = mQc[0];
	*disLowerEnd = mQc[mN];
}

void Edge::CalcSatArea
(
 void
)
{
	// ˰°Ѥη׻
	mSarea = 0.0;
	double wQsat = mA * mWidth * mDepth;
	for (int i = 1; i <= mN; i++)
	{
		// ־ü˰
		if (mQn[i-1] >= wQsat)
		{
			// ֲüǤ˰
			if (mQn[i] >= wQsat)
				mSarea += mWidth * mDx;
			// üǤ˰
			else
				mSarea += mWidth * mDx * 
					(wQsat - mQn[i-1]) / (mQn[i] - mQn[i-1]);
		}
		// üǤ˰
		else
		{
			// üǤ˰
			if (mQn[i] >= wQsat)
				mSarea += mWidth * 
					(mDx - mDx * (wQsat - mQn[i-1]) / (mQn[i] - mQn[i-1]));
			// üǤ˰
			else
				mSarea += 0.0;
		}
	}

	// added by Yutaka ICHIKAWA (Wed Sep  8 11:23:14 1999)
	mSarea *= mCos;
}

void Edge::CalcStorage
(
 void
)
{
// 	for (int i = 0; i <= mN; i++)
// 	{
// 		printf("%f ", mQn[i]);
// 	}
// 	printf("\n");

	double* wHn = new double[mN+1];
	for (int i = 0; i <= mN; i++)
	{
		// added by Yutaka ICHIKAWA 
		// Fri Sep 17 12:04:31 1999
		if (mQn[i] < 0.00000001) 
			wHn[i] = 0.0;
//		if (mQn[i]/mWidth <= mA * mDepth) // ήξ
		else if (mQn[i]/mWidth < mA * mDepth) // ήξ
			wHn[i] = mQn[i]/mWidth/mA;
		else
		{
			// ͤϡah  ad ǶƵޤ
			double h0 =
				mDepth + pow(((mQn[i]/mWidth - mA * mDepth)/mAlpha),1./mM);
			double v0 = pow(h0 - mDepth, mM - 1.);
			double q0 = mAlpha * v0 * (h0 - mDepth) + mA * h0;
			double q1;

			while (1)
			{
				h0 = h0 - (q0 - mQn[i]/mWidth)/(mAlpha * mM * v0 + mA);
				v0 = pow(h0 - mDepth, mM - 1.);
				q1 = mAlpha * v0 * (h0 - mDepth) + mA * h0;
				if (q1 > q0 - 0.0000001) break;
				q0 = q1;
			}

			wHn[i] = h0;
		}

//		printf("%f ", wHn[i]);
	}

//	printf("\n");

	mStorage = 0.0;
	for (int i = 1; i <= mN; i++)
	{
		mStorage += (wHn[i-1]+wHn[i]) * mDx * 0.5 * mWidth;
	}

//	printf("%f\n", mStorage);
	delete [] wHn;
}

Boolean Edge::Calculate
(
	double r					// ߿嶯 (mm/hour)
)
{
	// upstream end
	mQn[0] = 0.0;
	for (int i = 0; i < numberOfUpperEdges; i++)
	{
		if (upperEdgeNumArray[i] > 0) // ήå
		{
			mQn[0] += upperEdgeArray[i]->DischargeLowerEnd();
		}
	}
	mQn[0] *= mDist;			// ήʬΨ򤫤

	if (mAtr == 2)				// ή-ƻåξ
	{
		mQc[mN] = mQn[0];
		return (Boolean)YES;
	}

	double dta = mDt;			// time step (s)

	// lateral inflow
	double rLin = r * 0.001 / 3600.0 * mCos; // ߿嶯 (m/s)

	double qest; double cold; // double cnew; 
	double inflow_area = mUpperArea;

	for (int i = 1; i <= mN; i++)
	{
		qest = mQc[i];
		double wm = mWidth;
		inflow_area += wm * mDx;
		double delta_q = mQsmall * inflow_area;
		double a = mA;
		double q = 0.5 * (mQc[i-1] + mQc[i]) / wm;
		double d = mDepth;
		double alpha = mAlpha;

		cold = PropagationSpeed(alpha, a, d, delta_q / wm, q);
//		cold = PropagationSpeed(alpha, a, d, q*mEps, q);
		if (cold < mCmin) cold = mCmin;

		mQn[i] = (mQc[i] + mTheta * cold * 
			(dta/mDx * mQn[i-1] + dta * wm * rLin) - 
			(1. - mTheta) * cold * dta * 
			((mQc[i] - mQc[i-1])/mDx - rLin * wm)) / 
			(1. + mTheta * cold * dta / mDx);

		if (mQn[i] < 0.)
		{
			fprintf(stderr, "W: Negative discharge\n");
			fprintf(stderr, "mQn[i] : %f\n", mQn[i]);
			mQn[i] = 0.;
		}

// 		int count = 0;
// 
// 		double delta;
// 		int REPEAT = 40;
// 		double qestarray[REPEAT];
// 		while (count < REPEAT)
// 		{
// 			// for debugging
// 			qestarray[count] = qest;
// 
// 			double q = 0.5 * (mQn[i-1] + qest) / wm;
// 			cnew = PropagationSpeed(alpha, a, d, delta_q / wm, q);
// //			cnew = PropagationSpeed(alpha, a, d, mEps*q, q);
// 			if (cnew < mCmin) cnew = mCmin;
// 
// 			mQn[i] = (mQc[i] + mTheta * cnew * 
// 				(dta/mDx * mQn[i-1] + dta * wm * rLin) - 
// 				(1. - mTheta) * cold * dta * 
// 				((mQc[i] - mQc[i-1])/mDx - rLin * wm)) / 
// 				(1. + mTheta * cnew * dta / mDx);
// 
// 			if (mQn[i] < 0.)
// 			{
// 				cerr << "Warning! Negative discharge." << endl;
//  				cerr << "mQn[i] : " << mQn[i] << endl;
// 				mQn[i] = 0.;
// 			}
// 
// 			delta = mEps * qest;
// // 			delta = delta_q;
// // 			printf("%f\n", delta_q);
// // 			if (delta < delta_q) 
// // 			{
// // //				printf("here\n");
// // 				delta = delta_q;
// // 			}
// //			if (fabs(mQn[i] - qest) < delta) break;
// 			if (fabs(mQn[i] - qest) < 0.0000001) break;
// 
// 			if (count < 0.5 * REPEAT) qest = mQn[i]; // fast mode
// 			else qest = 0.5 * (qest + mQn[i]);		 // slow mode
// 			count++;
// 		}
// 
// 		if (count >= REPEAT)
// 		{
// 			cerr << "Convergence error: edge number " << Num() 
// 				 << " cross section " << i << endl;
// 			cerr << "mUpperArea " << mUpperArea << endl;
// 			cerr << "mArea " << mArea << endl;
// 			cerr << endl;
// 
// 			cerr << "discharge" << endl;
// 			for (int j = 0; j <= mN; j++)
// 			{
// 				cerr << j << " : " << mQc[j] << " " << mQn[j] << endl;
// 			}
// 			cerr << endl;
// 
// 			// for debugging
// 			cerr << "convergence threshold " << delta << endl;
// 			cerr << endl;
// 
// 			cerr << "iteration series of qest" << endl;
// 			for (int j = 0; j < REPEAT; j++)
// 				cerr << qestarray[j] << endl;
// 
// 			return (Boolean)NO;
// 		}
	}

	// ˰°Ѥη׻
	CalcSatArea();

	// for debugging
	CalcStorage();

	// update state variables
	for (int i = 0; i <= mN; i++)
	{
		mQc[i] = mQn[i];
	}

	return (Boolean)YES;
}

// double Edge::PropagationSpeed // ® c ׻֤
// (
//     double aAlpha,	    // ѥ᥿ $\alpha$
//     double aA,		    // ѥ᥿ a
//     double aDepth,	    // ѥ᥿ d
//     double aQeps,	    // «Ƚ
//     double aQunit	    // ñή
//     //
//     // $q = \alpha (h - d)^m + a h$
//     // $c = dq/dh = \alpha m (h - d)^(m-1) + a$
//     //
//     )
// {
// 	// Newton ˡǡб h ͤƤ顢®٤׻
// 	// 
// 
// 	if (aQunit <= aA * aDepth) // ήξ
// 	{
// 		return aA;
// 	}
// 
// 	double h0 =
// 		aDepth + pow(((aQunit - aA * aDepth)/aAlpha),1./mM);
//     	// ͤϡah  ad ǶƵޤ
// 	double v0 = pow(h0 - aDepth, mM - 1.);
// 	double q0 = aAlpha * v0 * (h0 - aDepth) + aA * h0;
// 	double q1;
// 
// 	while (1)
// 	{
// 		h0 = h0 - (q0 - aQunit)/(aAlpha * mM * v0 + aA);
// 		v0 = pow(h0 - aDepth, mM - 1.);
// 		q1 = aAlpha * v0 * (h0 - aDepth) + aA * h0;
// 		if (q1 > q0 - aQeps) break;
// 		q0 = q1;
// 	}
// 
// 	double c = aAlpha * mM * v0 + aA;
// 	return c;
// }

// This function was modified at ver. 4.1 --> 4.2
// by iYutaka (Mon Jan 29 11:42:24 2001)
double Edge::PropagationSpeed // ® c ׻֤
(
    double aAlpha,	    // ѥ᥿ $\alpha$
    double aA,		    // ѥ᥿ a
    double aDepth,	    // ѥ᥿ d
    double aQeps,	    // «Ƚ
    double aQunit	    // ñή
    //
    // $q = \alpha (h - d)^m + a h$
    // $c = dq/dh = \alpha m (h - d)^(m-1) + a$
    //
    )
{
	// ɽήξ, Ĥޤ A ؤʤ
	// (D = 0.0 ⤷ gamma = 0.0)
	if (aDepth == 0.0)
	{
		double wh = pow(aQunit / aAlpha, 1.0/mM);
		double c = aAlpha * mM * pow(wh, mM-1.0);
		return c;
	}

	// Newton ˡǡб h ͤƤ顢®٤׻
	// 

// 	if (aQunit <= aA * aDepth) // ήξ
	if (aQunit < aA * aDepth) // ήξ
	{
		return aA;
	}

	double h0 =
		aDepth + pow(((aQunit - aA * aDepth)/aAlpha),1./mM);
    	// ͤϡah  ad ǶƵޤ
	double v0 = pow(h0 - aDepth, mM - 1.);
	double q0 = aAlpha * v0 * (h0 - aDepth) + aA * h0;
	double q1;

	while (1)
	{
		h0 = h0 - (q0 - aQunit)/(aAlpha * mM * v0 + aA);
		v0 = pow(h0 - aDepth, mM - 1.);
		q1 = aAlpha * v0 * (h0 - aDepth) + aA * h0;
		if (q1 > q0 - aQeps) break;
		q0 = q1;
	}

	double c = aAlpha * mM * v0 + aA;
	return c;
}

//                                                      //
// --- 鲼 KsEdge ˴ؤ implementation --- //
//                                                      //

KsEdge::KsEdge(char* o_name, int o_num) : Element()
{
	class_name = "KsEdge";
	Init(o_name, o_num);
}

Boolean KsEdge::Init(char* o_name, int o_num)
{
	// rp,sp ν
	rp.Init("rp", 0);
	sp.Init("sp", 0);
	spSarea.Init("spSarea", 0);
	spStorage.Init("spStorage", 0);

	mSumRain = 0.0;
	mSumQout = 0.0;
	mStorage = 0.0;

	return Element::Init(o_name, o_num);
}

KsEdge::KsEdge(void) : Element()
{
	class_name = "KsEdge";
}

void KsEdge::Set_parameter(FILE* fp)
{
	int dt;						// time_step (s)
	char s1[256], s2[256];		// s1 : edge connection V.? ե
								// s2 : Ʃ巸񤫤줿ե

 	if (fscanf(fp, "%d %s %s", &dt, s1, s2) != 3)
	{
		Eprint(__FILE__, __LINE__);
			// KsEdge::Set_parameter
			// can not read parameter file.
		Oprint();
		exit(1);
	}

	assert(dt > 0); mDt = dt;

	// åη׻¤٤줿 edge connection V.? ե
	// ɤ߹

	FILE* fpTopo;
	assert((fpTopo = dataFileOpen(s1)) != NULL);

	// [Data Format Name]: mTopoDataType 

	char buf[256];
	while (fgets(buf, 256, fpTopo) != NULL &&
		   strncmp(buf, "[Data Format Name]", 18) != 0) ;
	fgets(buf, 256, fpTopo);
	if (strncmp(buf, "edge connection V.1", 19) == 0)
	{
		mTopoDataType = 1;
	}
	else if (strncmp(buf, "edge connection V.2", 19) == 0)
	{
		mTopoDataType = 2;
	}
	else if (strncmp(buf, "edge connection V.3", 19) == 0)
	{
		mTopoDataType = 3;
	}
	else if (strncmp(buf, "edge connection V.4", 19) == 0)
	{
		mTopoDataType = 4;
	}
	else if (strncmp(buf, "edge connection V.5", 19) == 0)
	{
		mTopoDataType = 5;
	}
	else
	{
		Eprint(__FILE__, __LINE__);
	    	// KsEdge::Set_parameter
			// Invalid topographic data format.
		Oprint();
		exit(1);
	}

	while (fgets(buf, 256, fpTopo) != NULL &&
		   strncmp(buf, "[Number of Total Edges]", 23) != 0) ;

	long numEdges;				// åο
	fgets(buf, 256, fpTopo);
	assert(sscanf(buf, "%ld", &numEdges) == 1);
	assert(numEdges > 0); numberOfEdges = numEdges;
	assert((edgeArray = new Edge[numberOfEdges]) != NULL);

	while (fgets(buf, 256, fpTopo) != NULL &&
		   strncmp(buf, "[Data]", 6) != 0) ;

	double totalArea = 0.0;
	for (long i = 0; i < numberOfEdges; i++)
	{
		edgeArray[i].TopographicData(fpTopo, mTopoDataType);
		if (edgeArray[i].Atr() == 1) // ή-ή
			totalArea += edgeArray[i].Area();
	}
	fclose(fpTopo);
	Oprint();
	cout << "\ttotal area: " << totalArea << "(m2)" << endl;

	// åֹ򥭡ˤƥХʥĥ꡼Ĥ

	for (long i = 0; i < numberOfEdges; i++)
	{
		long num = edgeArray[i].Num();
		treeKeyedByEdgeNumber.Insert(num, &edgeArray[i]);
	}

	// ήη׻ɬפʥѥ᥿ͤɤ߹

	FILE* fpParam;
	assert((fpParam = dataFileOpen(s2)) != NULL);

	// [Data Format Name]
	while (fgets(buf, 256, fpParam) != NULL &&
		   strncmp(buf, "[Data Format Name]", 18) != 0) ;
	fgets(buf, 256, fpParam);
	if (strncmp(buf, "KsEdge Parameter Format", 23) != 0)
	{
		Eprint(__FILE__, __LINE__);
	    	// KsEdge::Set_parameter
			// Invalid data format.
		Oprint();
		exit(1);
	}

	// [Number of Total Edges]
	long numtmp;
	while (fgets(buf, 256, fpParam) != NULL &&
		   strncmp(buf, "[Number of Total Edges]", 23) != 0) ;
	fgets(buf, 256, fpParam);
	assert(sscanf(buf, "%ld", &numtmp) == 1);
	if (numtmp != numberOfEdges)
	{
		Eprint(__FILE__, __LINE__);
			// KsEdge::Set_parameter
			// Wrong number of total edges given in 
		fprintf(stderr, "%s.\n", s2);
		Oprint();
		exit(1);
	}

	// [Data]
	while (fgets(buf, 256, fpParam) != NULL &&
		   strncmp(buf, "[Data]", 6) != 0) ;

	long num;					// åֹ
	double man;					// ޥ˥󥰤ٷ (m-s)
	double m;					// 
	double k;					// Ʃ巸 (m/s)
	double d;					// Aظ (m)
	double gamma;				// ַͭΨ (-)
	double theta;				// (-)
	double cmin;				// minimun C = dQ/dA (m/s)
	double Qlevel;				// (mm/hour)
	double eps;					// (-)
	int ndiv;					// ʬ (-)

	for (long i = 0; i < numberOfEdges; i++)
	{
		if (fscanf(fpParam, "%ld %lf %lf %lf %lf %lf %lf %lf %lf %lf %d",
				   &num, &man, &m, &k, &d, &gamma, &theta, &cmin,
				   &Qlevel, &eps, &ndiv) != 11)
		{
			Eprint(__FILE__, __LINE__);
				// KsEdge::Set_parameter
				// can not read parameter file.
			fprintf(stderr, "File: %s\n", s2);
			Oprint();
			exit(1);
		}

		assert(num > 0);
		assert(man > 0.0);
		assert(m >= 1.0);
		assert(k >= 0.0);
		assert(d >= 0.0);
		assert(0.0 < gamma && gamma <= 1.0);
		assert(0.0 <= theta && theta <= 1.0);
		assert(cmin > 0.0);
		assert(Qlevel > 0.0);
		assert(eps > 0.0);
		assert(ndiv > 0);

		KeyData* pi = treeKeyedByEdgeNumber.GetPtrToData(num);
		if (pi == NULL)
		{
			Eprint(__FILE__, __LINE__);
				// KsEdge::Set_parameter
			fprintf(stderr, "Edge %ld was not found in edgeArray\n", num);
			Oprint();
			exit(1);
		}

		Edge* p = pi->Data();
		p->ParametersInFlowModel(man, m, k, d, gamma, theta, cmin,
								 Qlevel, eps, ndiv, dt);
	}

	// upperEdgeArray 

	for (long i = 0; i < numberOfEdges; i++)
	{
		int upnum = edgeArray[i].NumberOfUpperEdges();
		for (int j = 0; j < upnum; j++)
		{
			long num = abs(edgeArray[i].UpperEdgeNumArray(j));
			KeyData* pi = treeKeyedByEdgeNumber.GetPtrToData(num);
			if (pi == NULL)
			{	
				Eprint(__FILE__, __LINE__);
					// KsEdge::Set_parameter
				fprintf(stderr, "Edge %ld was not found in edgeArray\n", num);
				Oprint();
				exit(1);
			}

			Edge* p = pi->Data();
			assert(edgeArray[i].RegisterUpperEdge(p) == (Boolean)YES);
		}
	}

	// ⤷Ϸǡ edge connection V.1, V.2, V.4 ʤС
	// å DistributionRate, CalcUpperArea 
	// edge connection V.3, V.5 ʤ mSumArea ׻

	mSumArea = 0.0;

	if (mTopoDataType == 1 || mTopoDataType == 2 || mTopoDataType == 4)
	{
		for (long i = 0; i < numberOfEdges; i++)
		{
			edgeArray[i].DistributionRate();
			edgeArray[i].CalcUpperArea();
			mSumArea += edgeArray[i].Area();
		}
	}
	else
	{
		for (long i = 0; i < numberOfEdges; i++)
		{
			mSumArea += edgeArray[i].Area();
		}
	}

	// Wed Aug 18 21:18:47 1999
	// rp ǼΤ step Υǡ
	rp.Set_data_connection_type(1);
	// 0ʤޤ
	// 1ʤ step
	// 2ʤ pulse
}

void KsEdge::Set_initial_state(FILE* fp)
{
	if (fscanf(fp, "%ld %s", &current_time, edgeDisFileName) != 2)
	{
		Eprint(__FILE__, __LINE__);
	    	// KsEdge::Set_initial_state
			// Cannot read initial state file.
		Oprint();
		exit(1);
	}

	FILE* fpDis;
	char buf[256];
	assert((fpDis = dataFileOpen(edgeDisFileName)) != NULL);

	// [Data Format Name]
	while (fgets(buf, 256, fpDis) != NULL &&
		   strncmp(buf, "[Data Format Name]", 18) != 0) ;
	fgets(buf, 256, fpDis);
	if (strncmp(buf, "KsEdge Initial State Format", 27) != 0)
	{
		Eprint(__FILE__, __LINE__);
	    	// KsEdge::Set_initial_state
			// Invalid data format.
		Oprint();
		exit(1);
	}

	// [Number of Total Edges]
	long numtmp;
	while (fgets(buf, 256, fpDis) != NULL &&
		   strncmp(buf, "[Number of Total Edges]", 23) != 0) ;
	fgets(buf, 256, fpDis);
	assert(sscanf(buf, "%ld", &numtmp) == 1);
	if (numtmp != numberOfEdges)
	{
		Eprint(__FILE__, __LINE__);
	    	// KsEdge::Set_initial_state
			// Wrong number of total edges given in 
			fprintf(stderr, "%s.\n", edgeDisFileName);
		Oprint();
		exit(1);
	}

	// [Data]
	while (fgets(buf, 256, fpDis) != NULL &&
		   strncmp(buf, "[Data]", 6) != 0) ;

	for (long i = 0; i < numberOfEdges; i++)
	{
		long num;
		double updis, lowdis;
		if (fscanf(fpDis, "%ld %lf %lf", &num, &updis, &lowdis) != 3)
		{
			Eprint(__FILE__, __LINE__);
				// KsEdge::Set_initial_state
				// can not read discharge file.
			fprintf(stderr, "File: %s\n", edgeDisFileName);
			Oprint();
			exit(1);
		}

		assert(num > 0);
		assert(updis >= 0.0);
		assert(lowdis >= 0.0);

		KeyData* pi = treeKeyedByEdgeNumber.GetPtrToData(num);
		if (pi == NULL)
		{
			Eprint(__FILE__, __LINE__);
				// KsEdge::Set_initial_state
			fprintf(stderr, "Edge %ld was not found in edgeArray\n", num);
			Oprint();
			exit(1);
		}

		Edge* p = pi->Data();
		p->Discharge(updis, lowdis);
		p->CalcSatArea();
	}

	fclose(fpDis);
}

void KsEdge::Save_terminal_state(FILE* fp)
{
	assert(fp != NULL);

	// åξ岼üή̤Ͽե̾
	// 
// 	char s[256]; char* p = s;
// 	p = chgex(edgeDisFileName, "tst");
// 	// chgex ϥեγĥҤѹؿǤ
// 	// chgex.h Ƥޤ

	char s[256];
	strcpy(s, edgeDisFileName);
	strcat(s, ".tst");

	fprintf(fp, "%ld %s\n", current_time, s);

	FILE* fpDis;
//	fpDis = fopen(p, "w");
	fpDis = fopen(s, "w");

	char* commentSection = "[Comment]\nThese are discharge data at both ends of all edges.\nEach column in [Data] section is as follows:\n<edge number>\n<discharge at upper end(m3/s)>\n<discharge at lower end(m3/s)>\n" ;
	char* dataFormatNameSection = "[Data Format Name]\nKsEdge Initial State Format\n";
	char* numberOfTotalEdgesSection = "[Number of Total Edges]\n";
	char* dataSection = "[Data]\n";

	fprintf(fpDis, "%s", commentSection);
	fprintf(fpDis, "%s", dataFormatNameSection);
	fprintf(fpDis, "%s", numberOfTotalEdgesSection);
	fprintf(fpDis, "%ld\n", numberOfEdges);
	fprintf(fpDis, "%s", dataSection);

	for (long i = 0; i < numberOfEdges; i++)
	{
		long num = edgeArray[i].Num();
		double updis, lowdis;
		edgeArray[i].Discharge(&updis, &lowdis);
		fprintf(fpDis, "%ld %f %f\n", num, updis, lowdis);
	}

	fclose(fpDis);
}

Boolean KsEdge::Initial_output(void)
{
	mQoutc = 0.0;
	double sarea = 0.0;
	for (long i = 0; i < numberOfEdges; i++)
	{
		if (edgeArray[i].LowestEdge() == (Boolean)YES)
		{
			mQoutc += edgeArray[i].DischargeLowerEnd();
		}

		if (edgeArray[i].Atr() == 1)
		{
		    sarea += edgeArray[i].Sarea();
		}
	}

	sp.Send_data(current_time, mQoutc);
	spSarea.Send_data(current_time, sarea/mSumArea);
	spStorage.Send_data(current_time, mStorage);
	return (Boolean)YES;
}

Boolean KsEdge::Calculate(void)
{
	// ߿嶯
//	mRainn = rp.Get_data(current_time + time_step);
	// Wed Aug 18 21:19:01 1999
	mRainn = rp.Get_mean_data(current_time, current_time + time_step);

	// ޤǤ߿ (m3)
	mSumRain += mRainn * 0.001 / 3600.0 * (double)time_step * mSumArea;

	// next step ξ֤η׻
	mQoutn = 0.0;
	for (long i = 0; i < numberOfEdges; i++)
	{
		if (edgeArray[i].Calculate(mRainn) == (Boolean)NO)
		{
			Eprint(__FILE__, __LINE__);
				// 
			Oprint();
			exit(1);
		}

		// ⤷ edgeArray[i] ǲήåʤή̤
		// ­碌
		if (edgeArray[i].LowestEdge() == (Boolean)YES)
		{
			mQoutn += edgeArray[i].DischargeLowerEnd();
		}
	}

	// ˰°Ѥα̤׻
	double sarea = 0.0;
	double storage = 0.0;
	for (long i = 0; i < numberOfEdges; i++)
	{
		if (edgeArray[i].Atr() == 1) // ή-ήå
		{
			sarea += edgeArray[i].Sarea();
			storage += edgeArray[i].Storage();
		}
	}

	// ޤǤή
	mSumQout += (mQoutc + mQoutn) * (double)time_step * 0.5;

// 	// Ǥα
// 	mStorage = mSumRain - mSumQout;

	//  
	sp.Send_data(current_time + time_step, mQoutn);
	spSarea.Send_data(current_time + time_step, sarea/mSumArea);
//	spStorage.Send_data(current_time + time_step, mStorage);
	spStorage.Send_data(current_time + time_step, storage);

	mQoutc = mQoutn;

//	printf("%ld %f\n", current_time+time_step, mQoutn);
//	printf("%ld %f (%f)\n", current_time+time_step, mQout, mRainn);
//	printf("%f %f\n", mSumQout, mSumRain);
//	printf("%f %f\n", mQoutn, storage);

  	printf("[%s %d] %ld : %f\n", object_name, object_number,
  		current_time + time_step, mQoutn);

	return (Boolean)YES;
}
