/* mkPmtIst.cc */
/* $Lastupdate: Tue Oct  3 21:04:33 2000 $ */

/*

[ץ̾]

mkPmtIst.cc

[Сֹ]

ver. 3.0

[򤹤ץफ]

mkPmtIst.cc ϡKsEdge ǥ

  o ѥ᥿ե (KsEdge Parameter Format)
  o ή̥ե (KsEdge Initial State Format)

ץǤ

ver. 2.1 (Υץ) ϡedge connection V.1, V.2, V.3, V.4, V.5 
ˤбƤޤ

ޤǤΥץȤΰ㤤ϡ (ƥå岼üǤή) 
λǤϥեȤ edge connection V.1, V.2, V.4 ɤ߹
ϡޤ̤岼üή̤ɸϤϤ٤ƤΥå岼
üή̤Ʊˤʤޤedge connection V.3, V.5 ɤ߹ˤϡ׻
ϻήй (mm/hour) Ϳơƥå岼üˤ֤ή
׻̤ȤޤȤС׻ϻήй r, 
륨åξήѤ Au, ΥåѤ Ac Ȥȡ
åξüǤνή Qu, üǤνή Qc Ϥ줾졢

  Qu = r * Au
  Qc = r * (Au + Ac)

Ȥʤޤ

[Ȥ]

ʤǵưޤ

% mkPmtIst
# input file (edge connection V.1, V.2, V.3, V.4 or V.5) : iFile
# output file (KsEdge Parameter Format) : oFile1
# output file (KsEdge Initial State Format) : oFile2

# input values.
# [] means recommended value. () means unit system.

# manning coefficient (m-s) : 0.3
# kinematic parameter m [1.667](-) : 1.667
# permeability (m/s) : 0.01
# depth of A-layer (m) : 0.0
# porosity (-) : 1.0
# theta [0.65](-) : 0.65
# minimum value of C = dQ/dA [0.000001](m/s) : 0.0000001
# Qlevel [10](mm/hour) : 10
# eps [0.0001](-) : 0.0001
# number of spatial division (-) : 10

(edge connection V.1, V.2, V.4 ɤ߹)

# discharge at upper end (m3/s) : 0.0
# discharge at lower end (m3/s) : 0.0

(edge connection V.3, V.5 ɤ߹)

# initial runoff height (mm/hour) : 0.1

[ϥեΥեޥå]

edge connection V.1, V.2, V.3, V.4, V.5 Τ줫Ǥ⤫ޤޤ

[ѥ]

% make

*/

#include <iostream.h>
#include <fstream.h>
#include <strstream.h>
#include <iomanip.h>
#include <assert.h>
#include <stdlib.h>

#include "khboolean.h"
#include "khsimple.h"
#include "kherror.h"
#include "khstr.h"
#include "khdfstream.h"
#include "nopath.h"

void usage(const KhString& command)
{
  cerr
  << "\n" << command << " produces KsEdge Parameter Format data and KsEdge Initial State data\n"
  << "usage: " << command << " [options]\n"
  << "  options: \n"
  << "    -h  show this help message\n"
  << "    -v  show version number\n"
  << "  iFile  : edge connection V.1, V.2, V.3, V.4 or V.5 data\n"
  << "  oFile1 : KsEdge Parameter Format data\n"
  << "  oFile2 : KsEdge Initial State data\n"
  << "  \"iFile\", \"oFile1\" and \"oFile2\" will be read in from STDIN\n"
  << "  with prompting messages.\n" << endl;
  exit(1);
}

void version(void)
{
	cerr << "\nThis is mkPmtIst ver. 3.0\n"
		 << "developed by Yutaka ICHIKAWA, Kyoto Univ.\n" << endl;
}

int main						// ᥤץ
(
	int argc,
 	char** argv
)
{
	KhString command = nopath(argv[0]);

  	// optstring ǡץȤƵʸꤷޤ
	char *optstring = "hv";

	int c;
	while((c = getopt(argc, argv, optstring)) != EOF)
	{
    	// getopt ϲϤץʸ֤ޤ
		switch (c) {
		  case 'v':
			version();
			break;
		  case 'h':
			// ץʸ h ֤Ƥν
			// fall through
		  default:
			usage(command);
		}
	}

	// argc ˤ, ޥ̾ȰθĿޤĤʤ
	// Ȥargc ˤ 1 ޤ

	if (argc != 1)
	{
		//  command ǤϡθĿ0ĤǤ
		usage(command);
	}

	char in[256], out[256], out2[256];
	double man;
	double m;
	double k;
	double d;
	double gamma;
	double theta;
	double cmin;
	double Qlevel;
	double eps;
	int ndiv;

	KhBoolean ans = NO;
	char wbuf[256];

	while (ans == NO) 
	{
		cout << "# input file (edge connection V.1, V.2, V.3, V.4 or V.5) : ";
		cin >> in;
		cout << in << "; ok? [y/n] : ";
		cin >> wbuf;
		if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
	}
	KhDfstream iFile(in);
	if (!iFile)
	{
		cerr << "E: no such file." << endl;
		exit(1);
	}

	KhString buf;
//	while (getline(iFile, buf) && buf != "[Data Format Name]") ;
	while (getline(iFile, buf) && 
 		   strncmp((const char *)buf, "[Data Format Name]", 18) != 0) ;
	getline(iFile, buf);
// 	if (buf != "edge connection V.1" && buf != "edge connection V.2" &&
// 		buf != "edge connection V.3")
	if (strncmp((const char *)buf, "edge connection V.1", 19) != 0 && 
		strncmp((const char *)buf, "edge connection V.2", 19) != 0 &&
		strncmp((const char *)buf, "edge connection V.3", 19) != 0 &&
		strncmp((const char *)buf, "edge connection V.4", 19) != 0 &&
		strncmp((const char *)buf, "edge connection V.5", 19) != 0)
	{
		cerr << "E: invalid data format." << endl;
		exit(1);
	}

	// ǡեޥåȤμ
	int topoDataType;
// 	if (buf == "edge connection V.1") topoDataType = 1;
// 	else if (buf == "edge connection V.2") topoDataType = 2;
// 	else topoDataType = 3;

	if (strncmp((const char *)buf, "edge connection V.1", 19) == 0)
		topoDataType = 1;
	else if (strncmp((const char *)buf, "edge connection V.2", 19) == 0)
		topoDataType = 2;
	else if (strncmp((const char *)buf, "edge connection V.3", 19) == 0)
		topoDataType = 3;
	else if (strncmp((const char *)buf, "edge connection V.4", 19) == 0)
		topoDataType = 4;
	else
		topoDataType = 5;

	ans = NO;
	while (ans == NO) 
	{
		cout << "# output file (KsEdge Parameter Format) : ";
		cin >> out;
		cout << out << "; ok? [y/n] : ";
		cin >> wbuf;
		if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
	}
	ans = NO;

	while (ans == NO) 
	{
		cout << "# output file (KsEdge Initial State Format) : ";
		cin >> out2;
		cout << out2 << "; ok? [y/n] : ";
		cin >> wbuf;
		if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
	}
	ans = NO;

	cout << "\n"
		 << "# input values.\n"
		 << "# [] means recommended value. () means unit system.\n"
		 << endl;

	while (ans == NO) 
	{
		cout << "# manning coefficient (m-s) : ";
		cin >> man;
		cout << man << "; ok? [y/n] : ";
		cin >> wbuf;
		if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
	}
	ans = NO;

	while (ans == NO) 
	{
		cout << "# kinematic parameter m [1.667](-) : ";
		cin >> m;
		cout << m << "; ok? [y/n] : ";
		cin >> wbuf;
		if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
	}
	ans = NO;

	while (ans == NO) 
	{
		cout << "# permeability (m/s) : ";
		cin >> k;
		cout << k << "; ok? [y/n] : ";
		cin >> wbuf;
		if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
	}
	ans = NO;

	while (ans == NO) 
	{
		cout << "# depth of A-layer (m) : ";
		cin >> d;
		cout << d << "; ok? [y/n] : ";
		cin >> wbuf;
		if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
	}
	ans = NO;

	while (ans == NO) 
	{
		cout << "# porosity (-) : ";
		cin >> gamma;
		cout << gamma << "; ok? [y/n] : ";
		cin >> wbuf;
		if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
	}
	ans = NO;

	while (ans == NO) 
	{
		cout << "# theta [0.65](-) : ";
		cin >> theta;
		cout << theta << "; ok? [y/n] : ";
		cin >> wbuf;
		if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
	}
	ans = NO;

	while (ans == NO) 
	{
		cout << "# minimum value of C = dQ/dA [0.000001](m/s) : ";
		cin >> cmin;
		cout << cmin << "; ok? [y/n] : ";
		cin >> wbuf;
		if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
	}
	ans = NO;

	while (ans == NO) 
	{
		cout << "# Qlevel [10](mm/hour) : ";
		cin >> Qlevel;
		cout << Qlevel << "; ok? [y/n] : ";
		cin >> wbuf;
		if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
	}
	ans = NO;

	while (ans == NO) 
	{
		cout << "# eps [0.0001](-) : ";
		cin >> eps;
		cout << eps << "; ok? [y/n] : ";
		cin >> wbuf;
		if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
	}
	ans = NO;

	while (ans == NO) 
	{
		cout << "# number of spatial division (-) : ";
		cin >> ndiv;
		cout << ndiv << "; ok? [y/n] : ";
		cin >> wbuf;
		if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
	}
	ans = NO;

	// ̤

	double updis, lowdis;	   // å岼üǤή
	double irunoff;

	if (topoDataType == 1 || topoDataType == 2 || topoDataType == 4)
	{
		while (ans == NO) 
		{
			cout << "# discharge at upper end (m3/s) : ";
			cin >> updis;
			cout << updis << "; ok? [y/n] : ";
			cin >> wbuf;
			if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
		}
		ans = NO;

		while (ans == NO) 
		{
			cout << endl;
			cout << "# discharge at lower end (m3/s) : ";
			cin >> lowdis;
			cout << lowdis << "; ok? [y/n] : ";
			cin >> wbuf;
			if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
		}
		ans = NO;
	}
	else
	{
		while (ans == NO) 
		{
			cout << endl;
			cout << "# initial runoff height (mm/hour) : ";
			cin >> irunoff;
			cout << irunoff << "; ok? [y/n] : ";
			cin >> wbuf;
			if (wbuf[0] == 'y' || wbuf[0] == 'Y') ans = YES;
		}
	}

	ofstream oFile(out);
	ofstream oFile2(out2);

	oFile << "[Comment]\n" 
		  << "This data was generated from " << in 
		  << " by " << command << ".\n"
		  << "Each column in [Data] section is as follows:\n"
		  << "<edge number>\n<manning coefficient(m-s)>\n"
		  << "<kinematic parameter m(-)>\n<permeability(m/s)>\n"
		  << "<depth of A-layer(m)>\n"
		  << "<porosity(-)>\n<theta>\n<minimun C = dQ/dA(m/s)>\n"
		  << "<Qlevel(mm/hour)>\n<eps(-)>\n"
		  << "<number of spatial division(-)>"
		  << endl;

	oFile << "[Data Format Name]\n"
		  << "KsEdge Parameter Format" << endl;

	oFile2 << "[Comment]\n"
		   << "This data was generated from " << in 
		   << " by " << command << ".\n"
		   << "Each column in [Data] section is as follows:\n"
		   << "<edge number>\n"
		   << "<discharge at upper end(m3/s)>\n"
		   << "<discharge at lower end(m3/s)>"
		   << endl;

	oFile2 << "[Data Format Name]\n"
		   << "KsEdge Initial State Format" << endl;

//	while (getline(iFile, buf) && buf != "[Number of Total Edges]") ;
	while (getline(iFile, buf) && 
		   strncmp((const char *)buf, "[Number of Total Edges]", 23) != 0) ;

	long numberOfTotalEdges;
	getline(iFile, buf);
	istrstream strmbuf(buf);
	strmbuf >> numberOfTotalEdges;
	oFile << "[Number of Total Edges]\n" << numberOfTotalEdges << endl;
	oFile2 << "[Number of Total Edges]\n" << numberOfTotalEdges << endl;

//	while (getline(iFile, buf) && buf != "[Data]") ;
	while (getline(iFile, buf) && 
		   strncmp((const char *)buf, "[Data]", 6) != 0) ;

	oFile << "[Data]" << endl;
	oFile2 << "[Data]" << endl;

	while (getline(iFile, buf)) 
	{
		long num;				   // åֹ
		double x, y, z;			   // κɸ()
		long upperNode, lowerNode; // å岼üΥΡֹ
		double upx, upy, upz, lowx, lowy, lowz;	// å岼üκɸ()
		double upnum, lownum, tmp; // 岼ήåοֹ()
		int atr;				   // °
		double len, grd, area;	   // åĹۡ
		double dist, upArea;	   // ήʬΨή

		istrstream strmdata(buf);
		strmdata >> num ;

		if (topoDataType == 2 || topoDataType == 3)
			strmdata >> x >> y >> z ;
		else if (topoDataType == 4 || topoDataType == 5)
			strmdata >> upperNode >> upx >> upy >> upz 
				     >> lowerNode >> lowx >> lowy >> lowz ;

		strmdata >> upnum ;
		for (int i = 0; i < upnum; i++) strmdata >> tmp ;
		strmdata >> lownum ;
		for (int i = 0; i < lownum; i++) strmdata >> tmp ;
		strmdata >> atr ;

		if (atr == 1)			// ή-ήå
		{
			strmdata >> len >> grd >> area ;
		}
		else if (atr == 2)		// ή-ƻå
		{
			len = grd = area = 0.0;
		}
		else
		{
			strmdata >> len >> grd ;
			area = 0.0;
		}

		if (topoDataType == 3 || topoDataType == 5)
			strmdata >> dist >> upArea ;

		// ѥ᥿
		oFile << num << " " << man << " " << m << " " 
			  << k << " " << d << " " << gamma << " " 
			  << theta << " " << cmin << " " << Qlevel << " " 
			  << eps << " " << ndiv << endl;

		//  [m3/s]
		if (topoDataType == 1 || topoDataType == 2 || topoDataType == 4)
		{
			oFile2 << num << " " << updis << " " << lowdis << endl;
		}
		else
		{
			oFile2 << num << " " << irunoff * upArea * 0.001 / 3600.0 << " " 
				   << irunoff * (upArea + area) * 0.001 / 3600.0 << endl;
		}
	}

	return 0;
}
