// tksedge.cc

#include <stdio.h>
#include <time.h>

#include "total.h"				// class Total_system 
#include "p_tmp.h"
#include "ksedge.h"				// class KsEdge 

// 饹 VirtualRiverBasin 

class VirtualRiverBasin : public Total_system
{

  protected:

	// ü
	I_file<double> ip;		  // ߿嶯 (mm/hour)

	// üҤϿ
	void Register_input_ports(void)
 	{
 		Register((void*) &ip);
	}
	
  protected:

	// ü
	O_file<double> op;
	O_file<double> opSarea;
	O_file<double> opStorage;

	// üҤϿ
	void Register_output_ports(void)
	{
		Register((void*) &op);
		Register((void*) &opSarea);
		Register((void*) &opStorage);
	}
		
  protected:
	// 
	KsEdge ksedges;

	// ǤϿ
	void Register_components(void);

	// Ǵȿ׻ѤδؿʤΤǡȤʤ
	void Register_iterators(void) {}

  protected:
	// üҤ³
	void Connect_ports(void);

	// ľ̿ѤδؿʤΤǡȤʤ
	void Connect_components(void) {}

  public:
	// ֤
	virtual void Set_initial_state(FILE* fp)
	{
		fscanf(fp, "%ld", &current_time);
	}

  public:
	// 󥹥ȥ饯
	VirtualRiverBasin(void);

};

// ǤϿ
void VirtualRiverBasin::Register_components(void)
{
	Register((void*) &ksedges);
}

// üҤ³
void VirtualRiverBasin::Connect_ports(void)
{
	Connect(((void*) &ip), ((void*) &ksedges), "Receive", "rp", 0);
	Connect(((void*) &ksedges), "Send", "sp", 0, ((void*) &op));
	Connect(((void*) &ksedges), "Send", "spSarea", 0, ((void*) &opSarea));
	Connect(((void*) &ksedges), "Send", "spStorage", 0, ((void*) &opStorage));
}

// 󥹥ȥ饯
VirtualRiverBasin::VirtualRiverBasin(void)
	:	Total_system(),
		ip("tksedge.in"),
		op("tksedge.out"),
		opSarea("tksedge.sat"),
		opStorage("tksedge.stg"),
		ksedges("ksedges", 0)
{
	class_name = "VirtualRiverBasin";

	// ηϥ饹 
	// ("֥̾", "ֹ֥", "ȿ׻롼פο")
	Init("vrb", 0, 0);
}

// ᥤץ

int main(void)
{
    VirtualRiverBasin vrb;		// ηϥǥ

	if (vrb.Construct() != YES)
		{ printf("\n# Failure : Construct.\n"); return 1; }

	if (vrb.Switch() != YES)
		{ printf("\n# Failure : Switch.\n"); return 1; }
	
	if (vrb.Are_you_ready() != YES)
		{ printf("\n# Failure : Are_you_ready.\n"); return 1; }
	
	// ѥ᥿ե뤫ɤߤȤ
	vrb.Read_parameter_file("tksedge.pmt");

	// ֤ե뤫ɤߤȤ
	vrb.Read_initial_state_file("tksedge.ist");

	// üҥǡꥹȥ
	vrb.Read_send_port_file("tksedge.isd");
	
	vrb.Initial_work();
	vrb.Work();
	
	// ǽ֤ե¸
	vrb.Write_terminal_state("tksedge.tst");

	// üҤ˻ĤäƤǡե¸
	vrb.Write_send_port_stock("tksedge.tsd");
	return 0;
}
